//
//  main.cpp
//  Employee Search
//
//  Created by Isaac Candari on 2/13/24.
//

#include <iostream>
#include <fstream>
#include "Employee.hpp"


using namespace std;
int comparisons = 0;



// Function declaration for the merge function
void merge(Employee** employeeArray, int p, int q, int r);

// Recursive merge sort function
void mergeSort(Employee** employeeArray, int p, int r);



int main(int argc, char* argv[]) {
    cout << "You passed " << argc << " command-line parameters." << endl;
    cout << "Welcome to Employee Database";
    cout << " Here is all the employee information" << endl;

    // Check if a filename is provided as a command-line parameter
        if (argc != 2) {
            cerr << "Usage: " << argv[0] << "Please enter the program name followed by the file name." << endl;
            return 1; // Return an error code
        }
    
    ifstream ifs;
    ifs.open(argv[1], ios::in);
    
    
    if (!ifs.is_open()) {
            cerr << "Error opening file: " << argv[1] << endl;
            return 1; // Return an error code
        }
    

    
    string name, jobTitle, firstLine, hireYearString, idNumberString, ageString;
    int idNumber = 0, age = 0, hireYear; //local variables assigned for each part of the line
    
    
    getline(ifs, firstLine);
    
    int numberOfEmployees = stoi(firstLine); //turn the frist line into an integer
    Employee** employeeArray = new Employee*[numberOfEmployees]; //create a array with cells equal to number of lines

    //my first for-loop reads from the file
    for (int i=0; i<numberOfEmployees; i++) {
        getline(ifs, name, '|');
        getline(ifs, idNumberString, '|');
        getline(ifs, ageString, '|');
        getline(ifs, jobTitle, '|');
        getline(ifs, hireYearString);
        
        //now I need to convert the string numbers to integers
        
        hireYear = stoi(hireYearString);
        
        idNumber = stoi(idNumberString);
        
        age = stoi(ageString);
        
        employeeArray[i] = new Employee(name, idNumber, age, jobTitle, hireYear);
        
        
    }
    
    int numOfComparisons = 0;
    
    // for Selection Sort
    /*for (int i = 0; i < numberOfEmployees-1; i++) {
        int minIndex = i;
        for  (int j = i+1; j < numberOfEmployees; j++){
            numOfComparisons ++;
            if (employeeArray[j]->getID() < employeeArray[minIndex]->getID()){
                minIndex = j;
            }
        }
        //exchange using temporary variables
        Employee* temporaryVariable = employeeArray[i];
        
        employeeArray[i] = employeeArray[minIndex];
        employeeArray[minIndex] = temporaryVariable;
        
        for (int i = 0; i < numberOfEmployees; i++) {
                cout << employeeArray[i]->getID() << " ";
        }
            cout << endl;

    }*/
    
    mergeSort(employeeArray, 0, numberOfEmployees - 1);
    
    cout << "It took " << comparisons << " comparisons to sort the employee file." << endl;
     
    
    ofstream sortedFile("Sorted_Employee_Data.txt");
    
    if (!sortedFile.is_open()) {
            cerr << "Error opening sorted file for writing." << endl;
            return 1; // Return an error code
        }
    
    for (int i = 0; i < numberOfEmployees; i++) {
        sortedFile << employeeArray[i]->getName() << "|"
                    << employeeArray[i]->getID() << "|"
                    << employeeArray[i]->getAge() << "|"
                    << employeeArray[i]->getJob() << "|"
                    << employeeArray[i]->getHireYear() << endl;
    }
    
    sortedFile << "It took " << comparisons << " comparisons to sort the data." << endl;
    sortedFile.close();
    
    


    return 0;
}

// Merge function implementation
void merge(Employee** employeeArray, int p, int q, int r) {
    int nL = q - p + 1;
    int nR = r - q;

    Employee** LeftArray = new Employee*[nL];
    Employee** RightArray = new Employee*[nR];

    for (int i = 0; i < nL; i++)
        LeftArray[i] = employeeArray[p + i];

    for (int j = 0; j < nR; j++)
        RightArray[j] = employeeArray[q + j + 1];

    int i = 0, j = 0, k = p;

    while (i < nL && j < nR) {
        comparisons++;
        if (LeftArray[i]->getID() <= RightArray[j]->getID()) {
            employeeArray[k] = LeftArray[i];
            i++;
        } else {
            employeeArray[k] = RightArray[j];
            j++;
        }
        k++;
    }

    // Copy the remaining elements of L and R if any
    while (i < nL) {
        comparisons++;
        employeeArray[k] = LeftArray[i];
        i++;
        k++;
    }

    while (j < nR) {
        comparisons++;
        employeeArray[k] = RightArray[j];
        j++;
        k++;
    }

    // Cleanup temporary arrays
    delete[] LeftArray;
    delete[] RightArray;
}

// Merge sort function implementation
void mergeSort(Employee** employeeArray, int p, int r) {
    if (p < r) {
        int q = (p + r) / 2;
        
        // Recursively sort the two halves
        mergeSort(employeeArray, p, q);
        mergeSort(employeeArray, q + 1, r);
        
        // Merge the sorted halves
        merge(employeeArray, p, q, r);
    }
    
}

/*
 * multi
 * line
 * comment
 */
